diff --git a/web/pgadmin/feature_tests/xss_checks_file_manager_test.py b/web/pgadmin/feature_tests/xss_checks_file_manager_test.py
index 086ce58f..dccf45f0 100644
--- a/web/pgadmin/feature_tests/xss_checks_file_manager_test.py
+++ b/web/pgadmin/feature_tests/xss_checks_file_manager_test.py
@@ -99,12 +99,10 @@ class CheckFileManagerFeatureTest(BaseFeatureTest):
         self.page.find_by_id("file-input-path").send_keys(
             Keys.RETURN
         )
-        # Required sleep so that above action will be performed
-        time.sleep(0.05)
-        contents = self.page.find_by_id("contents").get_attribute('innerHTML')
-        # Required sleep so that content should be read before cancel
-        # the dialog
-        time.sleep(0.05)
+        contents = self.page.wait_for_element_to_reload(
+            lambda driver:
+            driver.find_element_by_css_selector("table#contents")
+        ).get_attribute('innerHTML')
         self.page.click_modal('Cancel')
         self.page.wait_for_query_tool_loading_indicator_to_disappear()
         self._check_escaped_characters(
diff --git a/web/regression/feature_utils/pgadmin_page.py b/web/regression/feature_utils/pgadmin_page.py
index 8ff66885..b7a25022 100644
--- a/web/regression/feature_utils/pgadmin_page.py
+++ b/web/regression/feature_utils/pgadmin_page.py
@@ -320,6 +320,13 @@ class PgadminPage:
 
         self._wait_for("app to start", page_shows_app, self.app_start_timeout)
 
+    def wait_for_element_to_reload(self, element_selector):
+        WebDriverWait(self.driver, 20)\
+            .until(EC.staleness_of(element_selector(self.driver)))
+        WebDriverWait(self.driver, 20)\
+            .until_not(EC.staleness_of(element_selector(self.driver)))
+        return element_selector(self.driver)
+
     def _wait_for(self, waiting_for_message, condition_met_function,
                   timeout=None):
         if timeout is None:
